package com.zswl.cloud.springBtach.server.core.api.dfy;

import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONUtil;
import com.zswl.cloud.springBatch.client.model.dfy.DfyRequestBase;
import com.zswl.cloud.springBatch.client.model.dfy.DomesticHotel.request.QueryNewRequest;
import com.zswl.cloud.springBatch.client.model.dfy.DomesticHotel.response.QueryNewResponse;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.request.ScenicListRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.response.ScenicListResponse;
import com.zswl.cloud.springBtach.server.core.dao.ApiLogDao;
import com.zswl.cloud.springBtach.server.core.domain.ApiLog;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class DomesticHotelApi {

    @Autowired
    ApiLogDao apiLogDao;

    @Value("${dfy.host}")
    private String host;

    @Value("${dfy.jd.acctId}")
    private String acctId;

    @Value("${dfy.jd.secretkey}")
    private String secretKey;


    @Value("${dfy.jd.apikey}")
    private String apiKey;

    // 景点列表查询

    public QueryNewResponse queryNew(QueryNewRequest queryNewRequest) {

        String post = post(queryNewRequest, "/DomesticHotel/hotel/destination/queryNew");

        return JSONUtil.toBean(post, QueryNewResponse.class);

    }

    private String post(DfyRequestBase dfyRequestBase, String url) {


        dfyRequestBase.setApiKey(apiKey);
        String signature = Signature.getSignature(JSONUtil.parseObj(dfyRequestBase), secretKey);
        dfyRequestBase.setSign(signature);

        String post = HttpUtil.post(host + url, JSONUtil.toJsonStr(dfyRequestBase));
        ApiLog apiLog = new ApiLog();
        apiLog.setSystem("difengyun");
        apiLog.setService(url);
        apiLog.setRequest(post);
        apiLog.setResponse(JSONUtil.toJsonStr(post));
        apiLogDao.save(apiLog);
        return post;

    }


}
