package com.zswl.cloud.springBtach.server.core.api.xiaoju.sdk.util;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

public abstract class HMacMD5 {
  private static byte[] md5(byte[] str) throws NoSuchAlgorithmException {
    MessageDigest md = MessageDigest.getInstance("MD5");
    md.update(str);
    return md.digest();
  }
  
  public static byte[] getHmacMd5Bytes(byte[] key, byte[] data) throws NoSuchAlgorithmException {
    int length = 64;
    byte[] ipad = new byte[length];
    byte[] opad = new byte[length];
    for (int i = 0; i < 64; i++) {
      ipad[i] = 54;
      opad[i] = 92;
    } 
    byte[] actualKey = key;
    byte[] keyArr = new byte[length];
    if (key.length > length)
      actualKey = md5(key); 
    int j;
    for (j = 0; j < actualKey.length; j++)
      keyArr[j] = actualKey[j]; 
    if (actualKey.length < length)
      for (j = actualKey.length; j < keyArr.length; j++)
        keyArr[j] = 0;  
    byte[] kIpadXorResult = new byte[length];
    for (int k = 0; k < length; k++)
      kIpadXorResult[k] = (byte)(keyArr[k] ^ ipad[k]); 
    byte[] firstAppendResult = new byte[kIpadXorResult.length + data.length];
    int m;
    for (m = 0; m < kIpadXorResult.length; m++)
      firstAppendResult[m] = kIpadXorResult[m]; 
    for (m = 0; m < data.length; m++)
      firstAppendResult[m + keyArr.length] = data[m]; 
    byte[] firstHashResult = md5(firstAppendResult);
    byte[] kOpadXorResult = new byte[length];
    for (int n = 0; n < length; n++)
      kOpadXorResult[n] = (byte)(keyArr[n] ^ opad[n]); 
    byte[] secondAppendResult = new byte[kOpadXorResult.length + firstHashResult.length];
    int i1;
    for (i1 = 0; i1 < kOpadXorResult.length; i1++)
      secondAppendResult[i1] = kOpadXorResult[i1]; 
    for (i1 = 0; i1 < firstHashResult.length; i1++)
      secondAppendResult[i1 + keyArr.length] = firstHashResult[i1]; 
    byte[] hmacMd5Bytes = md5(secondAppendResult);
    return hmacMd5Bytes;
  }
  
  public static String getHmacMd5Str(String key, String data) {
    String result = "";
    try {
      byte[] keyByte = key.getBytes("UTF-8");
      byte[] dataByte = data.getBytes("UTF-8");
      byte[] hmacMd5Byte = getHmacMd5Bytes(keyByte, dataByte);
      StringBuffer md5StrBuff = new StringBuffer();
      for (int i = 0; i < hmacMd5Byte.length; i++) {
        if (Integer.toHexString(0xFF & hmacMd5Byte[i]).length() == 1) {
          md5StrBuff.append("0").append(
              Integer.toHexString(0xFF & hmacMd5Byte[i]));
        } else {
          md5StrBuff.append(
              Integer.toHexString(0xFF & hmacMd5Byte[i]));
        } 
      } 
      result = md5StrBuff.toString().toUpperCase();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return result;
  }
  
  public static String genBaseString(String data, String accessSecret) {
    try {
      Mac mac = Mac.getInstance("HmacSHA256");
      mac.init(new SecretKeySpec(accessSecret.getBytes("UTF-8"), "HmacSHA256"));
      byte[] signData = mac.doFinal(data.getBytes("UTF-8"));
      return Base64.getEncoder().encodeToString(signData);
    } catch (NoSuchAlgorithmException|java.io.UnsupportedEncodingException|java.security.InvalidKeyException e) {
      throw new RuntimeException("HMAC-SHA1 not supported.");
    } 
  }
}
