package com.zswl.cloud.springBtach.server.core.controller;

import cn.hutool.json.JSONUtil;
import com.xiaoju.open.oil.commons.OilRequest;
import com.xiaoju.open.oil.core.executor.ResponseDTO;
import com.zhongshu.payment.client.model.order.v2.UpdateGoodsModel;
import com.zhongshu.payment.client.service.v2.OrderService2;
import com.zswl.cloud.springBtach.server.core.api.video.YqdSyncOrderModel;
import com.zswl.cloud.springBtach.server.core.dao.ApiLogDao;
import com.zswl.cloud.springBtach.server.core.domain.ApiLog;
import com.zswl.cloud.springBtach.server.core.service.XiaoJuService;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@Log4j2
@RestController
@RequestMapping("sync")
public class SycController {

    @Autowired
    XiaoJuService xiaoJuService;

    @Autowired
    ApiLogDao apiLogDao;

    @Autowired
    OrderService2 orderService2;


    @ApiOperation("推送-同步订单信息")
    @RequestMapping(value = "xiaoju/notifyOrderInfo", method = RequestMethod.POST)
    public ResponseDTO notifyOrderInfo(@RequestBody OilRequest oilRequest) {

        return xiaoJuService.notifyOrderInfo(oilRequest);
    }

    @ApiOperation("推送-同步加油站信息")
    @RequestMapping(value = "xiaoju/receivingGasStation", method = RequestMethod.POST)
    public ResponseDTO receivingGasStation(@RequestBody OilRequest oilRequest) {

        return xiaoJuService.notificationPushStoreInfoRequest(oilRequest);
    }

    @ApiOperation("同步视频会员支付状态")
    @RequestMapping(value = "yqd/orderState", method = RequestMethod.POST)
    public String receivingGasStation(@RequestBody YqdSyncOrderModel yqdSyncOrderModel) {

        if (!yqdSyncOrderModel.getStatus().equals(4)) {
            UpdateGoodsModel updateGoodsModel = new UpdateGoodsModel();
            updateGoodsModel.setId(yqdSyncOrderModel.getExternalOrderno());
            updateGoodsModel.setDelivery(false);
            orderService2.updateGoods(updateGoodsModel);
        }
        ApiLog apiLog = new ApiLog();
        apiLog.setSystem("video");
        apiLog.setRequest(JSONUtil.toJsonStr(yqdSyncOrderModel));
        apiLog.setService("syncOrderState");
        apiLog.setResponse("ok");
        apiLogDao.save(apiLog);
        return "ok";
    }
}
